package psapkg;

/* 	
	Class:	 	Polymer 
	Package:	psapkg
	Version: 	0.7
	By:	 	Sriranga Veeraraghavan
	Last Mod:	16 Mar 97 8:07 PM
*/

public class Polymer {
	public String name, state;
	public double mintensmod, maxtensmod;
	public double mintensstr, maxtensstr;
	public double minelong, maxelong;
	public double mintglass, maxtglass;
	public double mintmelt, maxtmelt;
	public double mindensity, maxdensity;
	public double conductivity;
	public double minelres, maxelres;
	public double minctf, maxctf;
	public long idNum;
	public double[] polyattrs = new double[10];
	private static long nextID = 0;
	
	public Polymer () {
		idNum = nextID++;
	}

	public Polymer (String polyname, double mintensm, double maxtensm,
		double mintenss, double maxtenss, double minel, double maxel,
		double mintg, double maxtg, double mintm, double maxtm) {
		
		this();

		name = polyname;
		mintensmod = mintensm;
		maxtensmod = maxtensm;
		mintensstr = mintenss;
		maxtensstr = maxtenss;
		minelong = minel;
		maxelong = maxel;
		mintglass = mintg;
		maxtglass = maxtg;
		mintmelt = mintm;
		maxtmelt = maxtm;

		polyattrs[0] = mintensm;
		polyattrs[1] = maxtensm;
		polyattrs[2] = mintenss;
		polyattrs[3] = maxtenss;
		polyattrs[4] = minel;
		polyattrs[5] = maxel;
		polyattrs[6] = mintg;
		polyattrs[7] = maxtg;
		polyattrs[8] = mintm;
		polyattrs[9] = maxtm;

	}

	public Polymer (String polyname, String statedes, double mindens, double maxdens, 
		double mintensm, double maxtensm, double mintenss, double maxtenss, double minel, 
		double maxel, double mintg, double maxtg, double mintm, double maxtm, double cond, 
		double minres, double maxres, double mincote, double maxcote) {
		
		this(polyname, mintensm, maxtensm, mintenss, maxtenss, minel, maxel, mintg, maxtg,
			mintm,maxtm);
		state = statedes;
		mindensity = mindens;
		maxdensity = maxdens;
		conductivity = cond;
		minelres = minres;
		maxelres = maxres;
		minctf = mincote;
		maxctf = maxcote;
		
	}

}