package psapkg;

import java.awt.*;
import java.util.Vector;
import psapkg.Polymer;

/*
	Class:	 	polyList
	Package:	psapkg
	Version: 	0.72
	By:	 	Sriranga Veeraraghavan
	Last Mod:	20 Apr 97 2:22 PM
*/

public class polyList extends Frame {
	List polymerlist = new List(8,false);
	TextArea polymerdata;
	Panel listpanel;
	Panel datapanel;
	Vector local_poly_vect = new Vector();
	
	public polyList (Vector poly_vect, String title) {
		for (int i = 0; i <= poly_vect.size()-1; i++) {
			Polymer currentpoly = (Polymer)poly_vect.elementAt(i);
			polymerlist.addItem(currentpoly.name);
			local_poly_vect.addElement(currentpoly);
		}
		initpolylist(title);
	}

	public void initpolylist(String title) {
		String disclaimerstr = "This data is not meant for specification purposes";
		String valuestr = "Values taken from Modern Plastics Encyclopedia 1988,1997";
		String copyrightstr = " Copyright 1987,1997 McGraw-Hill, Inc.";
		String sourcestr = valuestr + copyrightstr;		

		this.setBackground(Color.white);
		this.setTitle(title);
		this.setResizable(true);
		GridBagLayout gridbag = new GridBagLayout();
		GridBagConstraints c = new GridBagConstraints();
		this.setLayout(gridbag);		
		c.fill = GridBagConstraints.BOTH;
		c.weightx = 1.0;
		initlistpanel();	
		configureComp(listpanel,gridbag,c);
		c.gridwidth = GridBagConstraints.REMAINDER;
		initdatapanel();
		configureComp(datapanel,gridbag,c);
		c.weightx = 0.0;
		configureComp(new Label(disclaimerstr, Label.CENTER),gridbag,c);
		c.weightx = 0.0;
		configureComp(new Label(sourcestr, Label.CENTER),gridbag,c);
		c.weightx = 0.0;
		configureComp(new Button("Close"),gridbag,c);
		this.resize(500,200);
		this.show();
	}
	
	void configureComp(Component comp, GridBagLayout gbl, GridBagConstraints gbc) {
		gbl.setConstraints(comp,gbc);
		this.add(comp);
	}
		
	public void initlistpanel() {
		listpanel = new Panel();
		listpanel.setBackground(Color.white);
		listpanel.add("Center",polymerlist);
	}

	public void initdatapanel() {
		datapanel = new Panel();
		datapanel.setBackground(Color.white);
		polymerdata = new TextArea(8,40);
		polymerdata.setEditable(false);
		polymerdata.setFont(new Font("Dialog",Font.PLAIN,12));
		datapanel.add("Center", polymerdata);
	}

	public boolean action(Event event, Object arg) {
		if (event.target instanceof Button) {
			if (arg.equals("Close")) dispose();
		}
		return true;
	}
	
	public boolean handleEvent (Event event) {
		if (event.id == Event.WINDOW_DESTROY) {
			hide();
			return true;
		}

		if (event.id == Event.LIST_SELECT) {
			Polymer sp = 
				(Polymer)local_poly_vect.elementAt(polymerlist.getSelectedIndex());
			setpolydata(sp);
		}

		return super.handleEvent(event);
	}

	public void setpolydata(Polymer selectedpoly) {
			polymerdata.setText("");
			polymerdata.insertText
				(" " + selectedpoly.name + "\n\n", 0);
			
			if (selectedpoly.mintensmod == selectedpoly.maxtensmod) {
				polymerdata.appendText ("   Tensile Modulus (ksi):\t" 
					+ selectedpoly.mintensmod + "\n");
			} else {
				polymerdata.appendText ("   Tensile Modulus (ksi):\t"
					+ selectedpoly.mintensmod + " - " + selectedpoly.maxtensmod
					+ "\n");
			}

			if (selectedpoly.mintensstr == selectedpoly.maxtensstr) {
				polymerdata.appendText ("   Tensile Strength (ksi):\t" 
					+ selectedpoly.mintensstr + "\n");
			} else {
				polymerdata.appendText ("   Tensile Strength (ksi):\t"
					+ selectedpoly.mintensstr + " - " + selectedpoly.maxtensstr
					+ "\n");
			}

			if (selectedpoly.minelong == selectedpoly.maxelong) {
				polymerdata.appendText ("   Elongation at Break (%):\t" 
					+ selectedpoly.minelong + "\n");
			} else {
				polymerdata.appendText ("   Elongation at Break (%):\t"
					+ selectedpoly.minelong + " - " + selectedpoly.maxelong
					+ "\n");
			}

			if (selectedpoly.mintglass == selectedpoly.maxtglass) {
				if (selectedpoly.mintglass == -274 || 
					selectedpoly.maxtglass == -274) {
						polymerdata.appendText ("   Tg (C):\t\tNA\n");
				} else {
					polymerdata.appendText ("   Tg (C):\t\t" 
						+ selectedpoly.mintglass + "\n");
				}
			} else {
				polymerdata.appendText ("   Tg (C):\t\t"
					+ selectedpoly.mintglass + " - " + selectedpoly.maxtglass
					+ "\n");
			}

			if (selectedpoly.mintmelt == selectedpoly.maxtmelt) {
				if (selectedpoly.mintmelt == -274 || 
					selectedpoly.maxtmelt == -274) {
						polymerdata.appendText ("   Tm (C):\t\tNA\n");
				} else {
					polymerdata.appendText ("   Tm (C):\t\t" 
						+ selectedpoly.mintmelt + "\n");
				}
			} else {
				polymerdata.appendText ("   Tm (C):\t\t"
					+ selectedpoly.mintmelt + " - " + selectedpoly.maxtmelt
					+ "\n");
			}
	}
}