package psapkg;

import java.awt.*;
import java.util.Vector;
import psapkg.*;

/*
	Class:	 	searchPolyDBd
	Package:	psapkg
	Version: 	0.74
	By:	 	Sriranga Veeraraghavan
	Last Mod:	20 Apr 97 2:33 PM
*/

public class searchPolyDBd extends Frame {
	private static boolean isshowing = false;
	boolean erroroccured = false;
	Vector local_poly_vect = new Vector(35);
	public double reqtensmod = 0;
	public double reqtensstr = 0;
	public double reqelong = 0;
	public double reqtm = 0;
	public double reqtg = 0;
	String[] searchvarstrs = {"Tensile Modulus (ksi)", "Tensile Strength at Break (ksi)", 
		"Elongation at Break (%)", "Tg (C)", "Tm (C)"};
	String[] inputstrs = {" "," "," "," "," "};
	TextField[] searchinputs = new TextField[5];
	TextField errors;
	Panel paramspanel;

	public searchPolyDBd(Vector poly_vect) {	
		initSearchWindow();
		for (int i = 0; i <= poly_vect.size()-1; i++) 
			local_poly_vect.addElement((Polymer)poly_vect.elementAt(i));
	}

	void initSearchWindow() {
		this.setTitle("Search Database");
		this.setResizable(true);
		this.setBackground(Color.white);
		GridBagLayout gridbag = new GridBagLayout();
		GridBagConstraints c = new GridBagConstraints();
		this.setLayout(gridbag);
		c.fill = GridBagConstraints.BOTH;
		c.gridwidth = GridBagConstraints.REMAINDER;
		configureComp(new Label("Enter Search Parameters", Label.CENTER),gridbag,c);
		initParamsPanel();
		configureComp(paramspanel,gridbag,c);
		configureComp(new Label(" ",Label.CENTER),gridbag,c);
		configureComp(new Button("Search"),gridbag,c);
		configureComp(new Label(" ",Label.CENTER),gridbag,c);
		initerrors();
		configureComp(errors,gridbag,c);
		configureComp(new Label(" ",Label.CENTER),gridbag,c);
		configureComp(new Button("Close"),gridbag,c);
		this.resize(375,225);
		this.show();
		isshowing = true;
	}

	void configureComp(Component comp, GridBagLayout gbl, GridBagConstraints gbc) {
		gbl.setConstraints(comp,gbc);
		this.add(comp);
		gbc.weightx = 0.0;
	}

	void initerrors() {
		errors = new TextField(30);
		errors.setEditable(false);
	}

	void initParamsPanel() {
		paramspanel = new Panel();
		paramspanel.setBackground(Color.white);
		paramspanel.setLayout(new GridLayout(0,2,5,5));
		for (int i = 0; i < searchvarstrs.length; i++) {
			paramspanel.add(new Label(searchvarstrs[i] + ":",Label.LEFT));
			searchinputs[i] = new TextField(10);
			paramspanel.add(searchinputs[i]);
		}
	}

	public Insets insets() {
		return new Insets(5,5,5,5);
	}
	
	public boolean handleEvent (Event event) {
		if (event.id == Event.WINDOW_DESTROY) {
			dispose();
			isshowing = false;
			return true;
		}

		return super.handleEvent(event);
	}

	public boolean action(Event event, Object arg) {
		if (event.target instanceof Button) {
			if (arg.equals("Search")) {
				errors.setText("");
				getNums();
				if (!erroroccured) findMatches();
			}
			if (arg.equals("Close")) dispose();
		}
		return true;
	}

	void getNums() {
		Double rmb = new Double(0);
		Double rts = new Double(0);
		Double rel = new Double(0);
		Double rtg = new Double(0);
		Double rtm = new Double(0);
		boolean gavevaluetg = false;
		boolean gavevaluetm = false;

		erroroccured = false;

		for (int i = 0; i <= 4; i++) inputstrs[i] = searchinputs[i].getText();

		try {
			if (inputstrs[0].equals("")) inputstrs[0] = "-1";
			rmb = rmb.valueOf(inputstrs[0]);
			reqtensmod = rmb.doubleValue();
			if (reqtensmod < (double)-1) {
				errors.setText("Requested tensile modulus impossible, ignored");
				reqtensmod = (double)-1;
			}
		} catch (NumberFormatException e) {
			errors.setText("The requested tensile modulus is not a number");
			erroroccured = true;
		}

		try {
			if (inputstrs[1].equals("")) inputstrs[1] = "-1";
			rts = rts.valueOf(inputstrs[1]);
			reqtensstr = rts.doubleValue();
			if (reqtensstr < (double)-1) {
				errors.setText("Requested tensile strength impossible, ignored");
				reqtensstr = (double)-1;
			}
		} catch (NumberFormatException e) {
			errors.setText("Requested tensile strength is not a number");
			erroroccured = true;
		}

		try {
			if (inputstrs[2].equals("")) inputstrs[2] = "-1";
			rel = rel.valueOf(inputstrs[2]);
			reqelong = rel.doubleValue();
			if (reqelong < (double)-1) {
				errors.setText("Requested elongation impossible, ignored");
				reqelong = (double)-1;
			}
		} catch (NumberFormatException e) {
			errors.setText("Requested elongation is not a number");
			erroroccured = true;
		}

		try {
			if (inputstrs[3].equals("")) {
				inputstrs[3] = "-275";
				gavevaluetg = true;
			}
			rtg = rtg.valueOf(inputstrs[3]);
			reqtg = rtg.doubleValue();
			if (reqtg < (double)-273 && !gavevaluetg) {
				errors.setText("Requested Tg impossible, ignored");
				reqtg = (double)-275;
			}
		} catch (NumberFormatException e) {
			errors.setText("Requested Tg is not a number");
			erroroccured = true;
		}

		try {
			if (inputstrs[4].equals("")) {
				inputstrs[4] = "-275";
				gavevaluetm = true;
			}
			rtm = rtm.valueOf(inputstrs[4]);
			reqtm = rtm.doubleValue();
			if (reqtm < (double)-273 && !gavevaluetm) {
				errors.setText("Requested Tm impossible, ignored");
				reqtm = (double)-275;
			}
		} catch (NumberFormatException e) {
			errors.setText("Requested Tm is not a number");
			erroroccured = true;
		}	
	}

	void findMatches() {
		Vector match_vect = new Vector();
		Vector temp_match = new Vector();
		
//		fullGC();

		if (reqtensmod == (double)-1 && reqtensstr == (double)-1 && reqelong == (double)-1
			&& reqtg == (double)-275 && reqtm == (double)-275) {
			errors.setText("No search parameters");
		} else {
			errors.setText("Searching...");

			match_vect.removeAllElements();
			for(int i = 0; i <= local_poly_vect.size()-1;i++) {
				Polymer p = (Polymer)local_poly_vect.elementAt(i);
				if ((reqtensmod >= p.mintensmod && reqtensmod <= p.maxtensmod) ||
					reqtensmod == (double)-1) 
						match_vect.addElement(p);
			}
		
			for(int i = 0; i <= match_vect.size()-1;i++) {
				Polymer p = (Polymer)match_vect.elementAt(i);
				if ((reqtensstr >= p.mintensstr && reqtensstr <= p.maxtensstr) ||
					reqtensstr == (double)-1)
						temp_match.addElement(p);
			}
		
			remove(match_vect,temp_match);
			for(int i = 0; i <= match_vect.size()-1;i++) {
				Polymer p = (Polymer)match_vect.elementAt(i);
				if ((reqelong >= p.minelong && reqelong <= p.maxelong) ||
					reqelong == (double)-1)
						temp_match.addElement(p);
			}

			remove(match_vect,temp_match);
			for(int i = 0; i <= match_vect.size()-1;i++) {
				Polymer p = (Polymer)match_vect.elementAt(i);
				if ((reqtg >= p.mintglass && reqtg <= p.maxtglass) ||
					reqtg == (double)-275)
						temp_match.addElement(p);			
			}

			remove(match_vect,temp_match);
			for(int i = 0; i <= match_vect.size()-1;i++) {
				Polymer p = (Polymer)match_vect.elementAt(i);
				if ((reqtm >= p.mintmelt && reqtm <= p.maxtmelt) ||
					reqtm == (double)-275) 
						temp_match.addElement(p);
			}

			remove(match_vect, temp_match);

			if (match_vect.isEmpty()) {
				errors.setText("No matches were found");
			} else if (match_vect.size() == 1) {				
				String num_match = Integer.toString(match_vect.size(),10);
				new polyList(match_vect,num_match + " Match");
				errors.setText(num_match + " match was found");
			} else {
				String num_match = Integer.toString(match_vect.size(),10);
				new polyList(match_vect,num_match + " Matches");
				errors.setText(num_match + " matches were found");
			}

			match_vect.removeAllElements();
			temp_match.removeAllElements();
		}
	}

	void remove(Vector v1, Vector v2) {
		v1.removeAllElements();
		for (int i = 0; i <= v2.size()-1;i++) 
			v1.addElement((Polymer)v2.elementAt(i));
		v2.removeAllElements();
	}

	public static void fullGC() {
		Runtime rt = Runtime.getRuntime();
		long isFree = rt.freeMemory();
		long wasFree;
		do {
			wasFree = isFree;
			rt.gc();
			isFree = rt.freeMemory();
		} while (isFree > wasFree);
		rt.runFinalization();
	}
}





