package psapkg;

import java.awt.*;
import java.util.Vector;
import psapkg.*;

/*
	Class:	 	searchPolyDBn
	Package:	psapkg
	Version: 	0.73
	By:	 	Sriranga Veeraraghavan
	Last Mod:	20 Apr 97 2:22 PM
*/

public class searchPolyDBn extends Frame {
	Vector local_poly_vect = new Vector(35);
	Choice choice;
	TextField name,search_status;
		
	public searchPolyDBn(Vector poly_vect) {
		initSearchWindow();
		for (int i = 0; i <= poly_vect.size()-1; i++) 
			local_poly_vect.addElement((Polymer)poly_vect.elementAt(i));
	}

	void initSearchWindow() {
		this.setTitle("Search Database");
		this.setResizable(true);
		this.setBackground(Color.white);
		this.setLayout(new GridLayout(0,1,5,5));
		this.add(new Label("Search Database by Polymer Name",Label.CENTER));

		Panel centerpanel = new Panel();
		initcenterpanel(centerpanel);
		this.add(centerpanel);

		Panel buttonpanel = new Panel();
		initbuttonpanel(buttonpanel);
		this.add(buttonpanel);
		
		initsearchstatus();
		this.add(search_status);

		this.add(new Button("Close"));

		this.resize(350,125);
		this.show();
	}

	void initsearchstatus() {
		search_status = new TextField(30);
		search_status.setEditable(false);
	}

	void initcenterpanel(Panel p) {
		p.setLayout(new GridLayout(1,0,5,5));
		p.add(new Label("Polymer Name",Label.CENTER));

		initchoice();
		p.add(choice);

		name = new TextField(30);
		p.add(name);
	}

	void initbuttonpanel(Panel p) {
		p.setLayout(new GridLayout(1,0,5,5));
		p.add(new Button("Search"));
		p.add(new Button("Clear"));
	}
		
	void initchoice() {
		choice = new Choice();
		choice.addItem("starts with");
		choice.addItem("ends with");
		choice.addItem("is");
		choice.addItem("contains");
		choice.select("is");
	}

	public Insets insets() {
		return new Insets(10,10,10,10);
	}
	
	public boolean handleEvent (Event event) {
		if (event.id == Event.WINDOW_DESTROY) {
			dispose();
			return true;
		}
		return super.handleEvent(event);
	}

	public boolean action(Event event, Object arg) {
		if (event.target instanceof Button) {
			if (arg.equals("Search")) {
				String sc = choice.getSelectedItem();
				String sn = name.getText();
//				System.out.println(sc + " , " + sn + "\n");
				if (sn.equals("")) {
					search_status.setText("Please specify a polymer name");
				} else { 
					String sn_tmp = sn.trim();
					search_status.setText("Searching for polymer whose name " 
						+ sc + " " + sn_tmp + "...");
					findMatches(sc,sn_tmp.toLowerCase());
				}
			}
			if (arg.equals("Clear")) name.setText("");
			if (arg.equals("Close")) dispose();
		}
		return true;
	}

	void findMatches(String search_choice, String search_name) {
		Vector match_vect = new Vector();
		int sc = 0;
				
		if (search_choice.equals("starts with")) {
			sc = 1;
		} else if (search_choice.equals("ends with")) {
			sc = 2;
		} else if (search_choice.equals("contains")) {
			sc = 3;
		} else {	// default "is"
			sc = 0;
		}

		for (int i = 0; i <= local_poly_vect.size()-1;i++) {
			Polymer p = (Polymer)local_poly_vect.elementAt(i);
			String p_name = p.name.toLowerCase();

			if (sc == 1 && p_name.startsWith(search_name)) { 
				match_vect.addElement(p); 	// starts with
			} else if (sc == 2 && p_name.endsWith(search_name))  {	
				match_vect.addElement(p);	// ends with
			} else if (sc == 3 && p_name.indexOf(search_name) != -1) {
				match_vect.addElement(p);	// contains
			} else {				// is
				if (p_name.equals(search_name)) match_vect.addElement(p); 
			}
		}

		if (match_vect.isEmpty()) {
			search_status.setText("No matches were found");
		} else if (match_vect.size() == 1) {
			String num_match = Integer.toString(match_vect.size(),10);
			new polyList(match_vect,num_match + " Match");
			search_status.setText(num_match + " match was found");
		} else {
			String num_match = Integer.toString(match_vect.size(),10);
			new polyList(match_vect,num_match + " Matches");
			search_status.setText(num_match + " matches were found");
		}
		
		match_vect.removeAllElements();
	}
}



